Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationChannel.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationChannel.cc	(revision 1347)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// $Id: G4EvaporationChannel.cc,v 1.19 2010/11/24 15:30:49 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //J.M. Quesada (August2008). Based on:
@@ -30,18 +32,24 @@
 // by V. Lara (Oct 1998)
 //
-// Modif (03 September 2008) by J. M. Quesada for external choice of inverse 
-// cross section option
-// JMQ (06 September 2008) Also external choices have been added for 
-// superimposed Coulomb barrier (if useSICB is set true, by default is false) 
-
+// Modified:
+// 03-09-2008 J.M. Quesada for external choice of inverse cross section option
+// 06-09-2008 J.M. Quesada Also external choices have been added for superimposed 
+//                 Coulomb barrier (if useSICB is set true, by default is false) 
+// 17-11-2010 V.Ivanchenko in constructor replace G4VEmissionProbability by 
+//            G4EvaporationProbability and do not new and delete probability
+//            object at each call; use G4Pow
 
 #include "G4EvaporationChannel.hh"
 #include "G4PairingCorrection.hh"
-
-
-
-G4EvaporationChannel::G4EvaporationChannel(const G4int anA, const G4int aZ, const G4String & aName,
-					   G4VEmissionProbability * aEmissionStrategy,
-                                           G4VCoulombBarrier * aCoulombBarrier):
+#include "G4NucleiProperties.hh"
+#include "G4Pow.hh"
+#include "G4EvaporationLevelDensityParameter.hh"
+#include "Randomize.hh"
+#include "G4Alpha.hh"
+
+G4EvaporationChannel::G4EvaporationChannel(G4int anA, G4int aZ, 
+					   const G4String & aName,
+					   G4EvaporationProbability* aEmissionStrategy,
+                                           G4VCoulombBarrier* aCoulombBarrier):
     G4VEvaporationChannel(aName),
     theA(anA),
@@ -52,6 +60,24 @@
     MaximalKineticEnergy(-1000.0)
 { 
-    theLevelDensityPtr = new G4EvaporationLevelDensityParameter;
-//    MyOwnLevelDensity = true;  
+  ResidualA = 0;
+  ResidualZ = 0;
+  ResidualMass = CoulombBarrier=0.0;
+  EvaporatedMass = G4NucleiProperties::GetNuclearMass(theA, theZ);
+  theLevelDensityPtr = new G4EvaporationLevelDensityParameter;
+}
+
+G4EvaporationChannel::G4EvaporationChannel():
+    G4VEvaporationChannel(""),
+    theA(0),
+    theZ(0),
+    theEvaporationProbabilityPtr(0),
+    theCoulombBarrierPtr(0),
+    EmissionProbability(0.0),
+    MaximalKineticEnergy(-1000.0)
+{ 
+  ResidualA = 0;
+  ResidualZ = 0;
+  EvaporatedMass = ResidualMass = CoulombBarrier = 0.0;
+  theLevelDensityPtr = new G4EvaporationLevelDensityParameter;
 }
 
@@ -60,34 +86,4 @@
   delete theLevelDensityPtr;
 }
-
-G4EvaporationChannel::G4EvaporationChannel(const G4EvaporationChannel & ) : G4VEvaporationChannel()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationChannel::copy_costructor meant to not be accessable");
-}
-
-const G4EvaporationChannel & G4EvaporationChannel::operator=(const G4EvaporationChannel & )
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationChannel::operator= meant to not be accessable");
-    return *this;
-}
-
-G4bool G4EvaporationChannel::operator==(const G4EvaporationChannel & right) const 
-{
-    return (this == (G4EvaporationChannel *) &right);
-    //  return false;
-}
-
-G4bool G4EvaporationChannel::operator!=(const G4EvaporationChannel & right) const 
-{
-    return (this != (G4EvaporationChannel *) &right);
-    //  return true;
-}
-
-//void G4EvaporationChannel::SetLevelDensityParameter(G4VLevelDensityParameter * aLevelDensity)
-//  {
-//    if (MyOwnLevelDensity) delete theLevelDensityPtr;
-//    theLevelDensityPtr = aLevelDensity;
-//    MyOwnLevelDensity = false;
-//  }
 
 void G4EvaporationChannel::Initialize(const G4Fragment & fragment)
@@ -98,9 +94,10 @@
   theEvaporationProbabilityPtr->UseSICB(useSICB);
   
-  
-  G4int FragmentA = static_cast<G4int>(fragment.GetA());
-  G4int FragmentZ = static_cast<G4int>(fragment.GetZ());
+  G4int FragmentA = fragment.GetA_asInt();
+  G4int FragmentZ = fragment.GetZ_asInt();
   ResidualA = FragmentA - theA;
   ResidualZ = FragmentZ - theZ;
+  //G4cout << "G4EvaporationChannel::Initialize Z= " << theZ << " A= " << theA 
+  //	 << " FragZ= " << FragmentZ << " FragA= " << FragmentA << G4endl;
   
   //Effective excitation energy
@@ -108,17 +105,18 @@
     G4PairingCorrection::GetInstance()->GetPairingCorrection(FragmentA,FragmentZ);
   
-  
   // Only channels which are physically allowed are taken into account 
   if (ResidualA <= 0 || ResidualZ <= 0 || ResidualA < ResidualZ ||
       (ResidualA == ResidualZ && ResidualA > 1) || ExEnergy <= 0.0) {
-    CoulombBarrier=0.0;
+    CoulombBarrier = ResidualMass = 0.0;
     MaximalKineticEnergy = -1000.0*MeV;
     EmissionProbability = 0.0;
   } else {
+    ResidualMass = G4NucleiProperties::GetNuclearMass(ResidualA, ResidualZ);
+    G4double FragmentMass = fragment.GetGroundStateMass();
     CoulombBarrier = theCoulombBarrierPtr->GetCoulombBarrier(ResidualA,ResidualZ,ExEnergy);
     // Maximal Kinetic Energy
-    MaximalKineticEnergy = CalcMaximalKineticEnergy
-      (G4ParticleTable::GetParticleTable()->
-       GetIonTable()->GetNucleusMass(FragmentZ,FragmentA)+ExEnergy);
+    MaximalKineticEnergy = CalcMaximalKineticEnergy(FragmentMass + ExEnergy);
+    //MaximalKineticEnergy = ExEnergy + fragment.GetGroundStateMass() 
+    //  - EvaporatedMass - ResidualMass;
     
     // Emission probability
@@ -131,8 +129,8 @@
       limit= CoulombBarrier;
     else limit=0.;
+    limit = std::max(limit, FragmentMass - ResidualMass - EvaporatedMass);
   
     // The threshold for charged particle emission must be  set to 0 if Coulomb 
     //cutoff  is included in the cross sections
-    //if (MaximalKineticEnergy <= 0.0) EmissionProbability = 0.0;  
     if (MaximalKineticEnergy <= limit) EmissionProbability = 0.0;
     else { 
@@ -142,4 +140,5 @@
     }
   }
+  //G4cout << "G4EvaporationChannel:: probability= " << EmissionProbability << G4endl; 
   
   return;
@@ -148,39 +147,25 @@
 G4FragmentVector * G4EvaporationChannel::BreakUp(const G4Fragment & theNucleus)
 {
-  G4double EvaporatedKineticEnergy=GetKineticEnergy(theNucleus);
-  
-  G4double EvaporatedMass = G4ParticleTable::GetParticleTable()->GetIonTable()->
-    GetIonMass(theZ,theA);
-  G4double EvaporatedEnergy = EvaporatedKineticEnergy + EvaporatedMass;
-  
+  /*
+  G4double Ecm = GetKineticEnergy(theNucleus) + ResidualMass + EvaporatedMass;
+  
+  G4double EvaporatedEnergy = 
+    ((Ecm-ResidualMass)*(Ecm+ResidualMass) + EvaporatedMass*EvaporatedMass)/(2*Ecm);
+  */
+  G4double EvaporatedEnergy = GetKineticEnergy(theNucleus) + EvaporatedMass;
+
   G4ThreeVector momentum(IsotropicVector
-                         (std::sqrt(EvaporatedKineticEnergy*
-                                    (EvaporatedKineticEnergy+2.0*EvaporatedMass))));
-  
-  momentum.rotateUz(theNucleus.GetMomentum().vect().unit());
+                         (std::sqrt((EvaporatedEnergy - EvaporatedMass)*
+                                    (EvaporatedEnergy + EvaporatedMass))));
   
   G4LorentzVector EvaporatedMomentum(momentum,EvaporatedEnergy);
-  EvaporatedMomentum.boost(theNucleus.GetMomentum().boostVector());
+  G4LorentzVector ResidualMomentum = theNucleus.GetMomentum();
+  EvaporatedMomentum.boost(ResidualMomentum.boostVector());
   
   G4Fragment * EvaporatedFragment = new G4Fragment(theA,theZ,EvaporatedMomentum);
-#ifdef PRECOMPOUND_TEST
-  EvaporatedFragment->SetCreatorModel(G4String("G4Evaporation"));
-#endif
-  // ** And now the residual nucleus ** 
-  G4double theExEnergy = theNucleus.GetExcitationEnergy();
-  G4double theMass = G4ParticleTable::GetParticleTable()->GetIonTable()->
-    GetNucleusMass(static_cast<G4int>(theNucleus.GetZ()),
-                   static_cast<G4int>(theNucleus.GetA()));
-  G4double ResidualEnergy = theMass + 
-    (theExEnergy - EvaporatedKineticEnergy) - EvaporatedMass;
-  
-  G4LorentzVector ResidualMomentum(-momentum,ResidualEnergy);
-  ResidualMomentum.boost(theNucleus.GetMomentum().boostVector());
-  
-  G4Fragment * ResidualFragment = new G4Fragment(ResidualA, ResidualZ, ResidualMomentum );
-  
-#ifdef PRECOMPOUND_TEST
-  ResidualFragment->SetCreatorModel(G4String("ResidualNucleus"));
-#endif
+  ResidualMomentum -= EvaporatedMomentum;
+
+  G4Fragment * ResidualFragment = new G4Fragment(ResidualA, ResidualZ, ResidualMomentum);
+ 
   G4FragmentVector * theResult = new G4FragmentVector;
   
@@ -211,14 +196,10 @@
 /////////////////////////////////////////
 // Calculates the maximal kinetic energy that can be carried by fragment.
-G4double G4EvaporationChannel::CalcMaximalKineticEnergy(const G4double NucleusTotalE)
-{
-  G4double ResidualMass = G4ParticleTable::GetParticleTable()->
-    GetIonTable()->GetNucleusMass( ResidualZ, ResidualA );
-  G4double EvaporatedMass = G4ParticleTable::GetParticleTable()->
-    GetIonTable()->GetNucleusMass( theZ, theA );
-
+G4double G4EvaporationChannel::CalcMaximalKineticEnergy(G4double NucleusTotalE)
+{
   // This is the "true" assimptotic kinetic energy (from energy conservation)	
-  G4double Tmax = (NucleusTotalE*NucleusTotalE + EvaporatedMass*EvaporatedMass - 		
-                   ResidualMass*ResidualMass)/(2.0*NucleusTotalE) - EvaporatedMass;
+  G4double Tmax = 
+    ((NucleusTotalE-ResidualMass)*(NucleusTotalE+ResidualMass) + EvaporatedMass*EvaporatedMass)
+    /(2.0*NucleusTotalE) - EvaporatedMass;
   
   //JMQ (13-09-08) bug fixed: in the original version the Tmax is calculated
@@ -245,8 +226,8 @@
     
     
-    if (MaximalKineticEnergy < 0.0)   
+    if (MaximalKineticEnergy < 0.0) {
       throw G4HadronicException(__FILE__, __LINE__, 
                                 "G4EvaporationChannel::CalcKineticEnergy: maximal kinetic at the Coulomb barrier is less than 0");
-    
+    }
     G4double Rb = 4.0*theLevelDensityPtr->
       LevelDensityParameter(ResidualA+theA,ResidualZ+theZ,MaximalKineticEnergy)*
@@ -263,6 +244,6 @@
       G4double Q2 = 1.0;
       if (theZ == 0) { // for emitted neutron
-        G4double Beta = (2.12/std::pow(G4double(ResidualA),2./3.) - 0.05)*MeV/
-          (0.76 + 2.2/std::pow(G4double(ResidualA),1./3.));
+        G4double Beta = (2.12/G4Pow::GetInstance()->Z23(ResidualA) - 0.05)*MeV/
+          (0.76 + 2.2/G4Pow::GetInstance()->Z13(ResidualA));
         Q1 = 1.0 + Beta/(MaximalKineticEnergy);
         Q2 = Q1*std::sqrt(Q1);
@@ -277,16 +258,18 @@
   } else if (OPTxs==1 || OPTxs==2 || OPTxs==3 || OPTxs==4) {
     
-    G4double V;
-    if(useSICB) V= CoulombBarrier;
-    else V=0.;
-    //If Coulomb barrier is just included  in the cross sections
-    // 	G4double V=0.;
+    // Coulomb barrier is just included  in the cross sections
+    G4double V = 0;
+    if(useSICB) { V= CoulombBarrier; }
+
+    V = std::max(V, aFragment.GetGroundStateMass()-EvaporatedMass-ResidualMass);
 
     G4double Tmax=MaximalKineticEnergy;
     G4double T(0.0);
     G4double NormalizedProbability(1.0);
-    
+
+    // VI: This is very ineffective - create new objects at each call to the method    
+    /*
     // A pointer is created in order to access the distribution function.
-    G4EvaporationProbability * G4EPtemp;
+    G4EvaporationProbability * G4EPtemp = 0;
     
     if (theA==1 && theZ==0) G4EPtemp=new G4NeutronEvaporationProbability();
@@ -305,15 +288,18 @@
       G4EPtemp->SetOPTxs(OPTxs);
       G4EPtemp->UseSICB(useSICB);
-
+    */
+
+    // use local pointer and not create a new one
     do
       {  
         T=V+G4UniformRand()*(Tmax-V);
-        NormalizedProbability=G4EPtemp->ProbabilityDistributionFunction(aFragment,T)/
-          (this->GetEmissionProbability());
+        NormalizedProbability = 
+	  theEvaporationProbabilityPtr->ProbabilityDistributionFunction(aFragment,T)/
+          GetEmissionProbability();
         
       }
     while (G4UniformRand() > NormalizedProbability);
-   delete G4EPtemp;
-   return T;
+    //   delete G4EPtemp;
+    return T;
   } else{
     std::ostringstream errOs;
@@ -323,16 +309,16 @@
 }
 
-G4ThreeVector G4EvaporationChannel::IsotropicVector(const G4double Magnitude)
+G4ThreeVector G4EvaporationChannel::IsotropicVector(G4double Magnitude)
     // Samples a isotropic random vectorwith a magnitud given by Magnitude.
     // By default Magnitude = 1.0
 {
-    G4double CosTheta = 1.0 - 2.0*G4UniformRand();
-    G4double SinTheta = std::sqrt(1.0 - CosTheta*CosTheta);
-    G4double Phi = twopi*G4UniformRand();
-    G4ThreeVector Vector(Magnitude*std::cos(Phi)*SinTheta,
-			 Magnitude*std::sin(Phi)*SinTheta,
-			 Magnitude*CosTheta);
-    return Vector;
-            }
+  G4double CosTheta = 1.0 - 2.0*G4UniformRand();
+  G4double SinTheta = std::sqrt(1.0 - CosTheta*CosTheta);
+  G4double Phi = twopi*G4UniformRand();
+  G4ThreeVector Vector(Magnitude*std::cos(Phi)*SinTheta,
+		       Magnitude*std::sin(Phi)*SinTheta,
+		       Magnitude*CosTheta);
+  return Vector;
+}
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EvaporationDefaultGEMFactory.cc,v 1.2 2010/04/27 11:43:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EvaporationFactory.cc,v 1.5 2010/04/27 11:43:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc	(revision 1347)
@@ -44,67 +44,59 @@
 #include "G4IonTable.hh"
 
-
-G4EvaporationProbability::G4EvaporationProbability(const G4EvaporationProbability &) : G4VEmissionProbability()
+G4EvaporationProbability::G4EvaporationProbability(G4int anA, G4int aZ, 
+						   G4double aGamma,
+						   G4VCoulombBarrier * aCoulombBarrier) 
+  : theA(anA),
+    theZ(aZ),
+    Gamma(aGamma),
+    theCoulombBarrierptr(aCoulombBarrier) 
+{}
+
+G4EvaporationProbability::G4EvaporationProbability()
+  : theA(0),
+    theZ(0),
+    Gamma(0.0),
+    theCoulombBarrierptr(0) 
+{}
+
+G4EvaporationProbability::~G4EvaporationProbability() 
+{}
+  
+G4double 
+G4EvaporationProbability::EmissionProbability(const G4Fragment & fragment, G4double anEnergy)
 {
-    throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationProbability::copy_constructor meant to not be accessable");
-}
-
-
-
-
-const G4EvaporationProbability & G4EvaporationProbability::
-operator=(const G4EvaporationProbability &)
+  G4double EmissionProbability = 0.0;
+  G4double MaximalKineticEnergy = anEnergy;
+
+  if (MaximalKineticEnergy > 0.0 && fragment.GetExcitationEnergy() > 0.0) {
+    EmissionProbability = CalculateProbability(fragment, MaximalKineticEnergy);
+
+  }
+  return EmissionProbability;
+}
+
+////////////////////////////////////
+
+// Computes the integrated probability of evaporation channel
+G4double 
+G4EvaporationProbability::CalculateProbability(const G4Fragment & fragment, 
+					       G4double MaximalKineticEnergy)
 {
-    throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationProbability::operator= meant to not be accessable");
-    return *this;
-}
-
-
-G4bool G4EvaporationProbability::operator==(const G4EvaporationProbability &) const
-{
-    return false;
-}
-
-G4bool G4EvaporationProbability::operator!=(const G4EvaporationProbability &) const
-{
-    return true;
-}
-  
-G4double G4EvaporationProbability::EmissionProbability(const G4Fragment & fragment, const G4double anEnergy)
-{
-    G4double EmissionProbability = 0.0;
-    G4double MaximalKineticEnergy = anEnergy;
-
-    if (MaximalKineticEnergy > 0.0 && fragment.GetExcitationEnergy() > 0.0) {
-	EmissionProbability = CalculateProbability(fragment, MaximalKineticEnergy);
-
-    }
-    return EmissionProbability;
-}
-
-////////////////////////////////////
-
-// Computes the integrated probability of evaporation channel
-G4double G4EvaporationProbability::CalculateProbability(const G4Fragment & fragment, const G4double MaximalKineticEnergy)
-{
-    G4double ResidualA = fragment.GetA() - theA;
-    G4double ResidualZ = fragment.GetZ() - theZ;
-    G4double U = fragment.GetExcitationEnergy();
+  G4int ResidualA = fragment.GetA_asInt() - theA;
+  G4int ResidualZ = fragment.GetZ_asInt() - theZ;
+  G4double U = fragment.GetExcitationEnergy();
    
- if (OPTxs==0) {
-
-	
-    G4double NuclearMass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetNucleusMass(theZ,theA);
-
-
-    G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(fragment.GetA()),
-									       static_cast<G4int>(fragment.GetZ()));
-
-    G4double SystemEntropy = 2.0*std::sqrt(theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),
-									   static_cast<G4int>(fragment.GetZ()),U)*
-				      (U-delta0));
+  if (OPTxs==0) {
+
+    G4double NuclearMass = fragment.ComputeGroundStateMass(theZ,theA);
+
+    G4double delta0 = fPairCorr->GetPairingCorrection(fragment.GetA_asInt(),
+						      fragment.GetZ_asInt());
+
+    G4double SystemEntropy = 2.0*std::sqrt(
+      theEvapLDPptr->LevelDensityParameter(fragment.GetA_asInt(),fragment.GetZ_asInt(),U)*
+      (U-delta0));
 								  
-
-    G4double RN = 1.5*fermi;
+    const G4double RN = 1.5*fermi;
 
     G4double Alpha = CalcAlphaParam(fragment);
@@ -112,18 +104,16 @@
 	
     G4double Rmax = MaximalKineticEnergy;
-    G4double a = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(ResidualA),
-						      static_cast<G4int>(ResidualZ),
-						      Rmax);
-    G4double GlobalFactor = static_cast<G4double>(Gamma) * (Alpha/(a*a)) *
-	(NuclearMass*RN*RN*std::pow(ResidualA,2./3.))/
-	(2.*pi* hbar_Planck*hbar_Planck);
+    G4double a = theEvapLDPptr->LevelDensityParameter(ResidualA,ResidualZ,Rmax);
+    G4double GlobalFactor = Gamma * Alpha/(a*a) *
+	(NuclearMass*RN*RN*fG4pow->Z23(ResidualA))/
+	(twopi* hbar_Planck*hbar_Planck);
     G4double Term1 = (2.0*Beta*a-3.0)/2.0 + Rmax*a;
     G4double Term2 = (2.0*Beta*a-3.0)*std::sqrt(Rmax*a) + 2.0*a*Rmax;
 	
     G4double ExpTerm1 = 0.0;
-    if (SystemEntropy <= 600.0) ExpTerm1 = std::exp(-SystemEntropy);
+    if (SystemEntropy <= 600.0) { ExpTerm1 = std::exp(-SystemEntropy); }
 	
     G4double ExpTerm2 = 2.*std::sqrt(a*Rmax) - SystemEntropy;
-    if (ExpTerm2 > 700.0) ExpTerm2 = 700.0;
+    if (ExpTerm2 > 700.0) { ExpTerm2 = 700.0; }
     ExpTerm2 = std::exp(ExpTerm2);
 	
@@ -134,23 +124,25 @@
  } else if (OPTxs==1 || OPTxs==2 ||OPTxs==3 || OPTxs==4) {
 
-   G4double limit;
-   if (useSICB) limit=theCoulombBarrierptr->GetCoulombBarrier(G4lrint(ResidualA),G4lrint(ResidualZ),U);
-   else limit=0.;
-
-   if (MaximalKineticEnergy <= limit)  return 0.0;
-
-
-   // if Coulomb barrier cutoff is superimposed for all cross sections the limit is the Coulomb Barrier
+   G4double EvaporatedMass = fragment.ComputeGroundStateMass(theZ,theA);
+   G4double ResidulalMass = fragment.ComputeGroundStateMass(ResidualZ,ResidualA);
+   G4double limit = std::max(0.0,fragment.GetGroundStateMass()-EvaporatedMass-ResidulalMass);
+   if (useSICB) {
+     limit = std::max(limit,theCoulombBarrierptr->GetCoulombBarrier(ResidualA,ResidualZ,U));
+   }
+
+   if (MaximalKineticEnergy <= limit) { return 0.0; }
+
+   // if Coulomb barrier cutoff is superimposed for all cross sections 
+   // then the limit is the Coulomb Barrier
    G4double LowerLimit= limit;
 
-   //  MaximalKineticEnergy: asimptotic value (already accounted for in G4EvaporationChannel)     
+   //MaximalKineticEnergy: asimptotic value (already accounted for in G4EvaporationChannel)     
 
    G4double UpperLimit = MaximalKineticEnergy;
 
-
    G4double Width = IntegrateEmissionProbability(fragment,LowerLimit,UpperLimit);
 
    return Width;
- } else{
+ } else {
    std::ostringstream errOs;
    errOs << "Bad option for cross sections at evaporation"  <<G4endl;
@@ -163,7 +155,7 @@
 
 G4double G4EvaporationProbability::
-IntegrateEmissionProbability(const G4Fragment & fragment, const G4double & Low, const G4double & Up )
+IntegrateEmissionProbability(const G4Fragment & fragment, 
+			     const G4double & Low, const G4double & Up )
 {
-
   static const G4int N = 10;
   // 10-Points Gauss-Legendre abcisas and weights
@@ -212,43 +204,46 @@
 //New method (OPT=1,2,3,4)
 
-G4double G4EvaporationProbability::ProbabilityDistributionFunction( const G4Fragment & fragment, const G4double K)
+G4double 
+G4EvaporationProbability::ProbabilityDistributionFunction( const G4Fragment & fragment, 
+							   G4double K)
 { 
-
+  G4int ResidualA = fragment.GetA_asInt() - theA;
+  G4int ResidualZ = fragment.GetZ_asInt() - theZ;  
+  G4double U = fragment.GetExcitationEnergy();
+  //G4cout << "### G4EvaporationProbability::ProbabilityDistributionFunction" << G4endl;
+  //G4cout << "FragZ= " << fragment.GetZ_asInt() << " FragA= " << fragment.GetA_asInt()
+  //	 << " Z= " << theZ << "  A= " << theA << G4endl;
+  //G4cout << "PC " << fPairCorr << "   DP " << theEvapLDPptr << G4endl;
+
+  // if(K <= theCoulombBarrierptr->GetCoulombBarrier(ResidualA,ResidualZ,U)) return 0.0;
+
+  G4double delta1 = fPairCorr->GetPairingCorrection(ResidualA,ResidualZ);
  
-
-
-  G4double ResidualA = fragment.GetA() - theA;
-  G4double ResidualZ = fragment.GetZ() - theZ;  
-  G4double U = fragment.GetExcitationEnergy();
-
-  //        if(K <= theCoulombBarrierptr->GetCoulombBarrier(G4lrint(ResidualA),G4lrint(ResidualZ),U)) return 0.0;   
-
-  G4double delta1 = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(ResidualA),static_cast<G4int>(ResidualZ));
-
- 
-  G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(fragment.GetA()),static_cast<G4int>(fragment.GetZ()));
-
-  
-  G4double ParticleMass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetNucleusMass(theZ,theA);
-
-  G4double theSeparationEnergy= G4NucleiProperties::GetMassExcess(static_cast<G4int>(theA),static_cast<G4int>(theZ)) +
-    G4NucleiProperties::GetMassExcess(static_cast<G4int>(ResidualA),static_cast<G4int>(ResidualZ)) -
-    G4NucleiProperties::GetMassExcess(static_cast<G4int>(fragment.GetA()),static_cast<G4int>(fragment.GetZ()));
-
-  G4double a0 = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),static_cast<G4int>(fragment.GetZ()),U - delta0);
-
-  G4double a1 = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(ResidualA),static_cast<G4int>(ResidualZ),U - theSeparationEnergy - delta1);
-  
-  
-  G4double E0=U-delta0;
-
-  G4double E1=U-theSeparationEnergy-delta1-K;
-
-  if (E1<0.) return 0.;
+  G4double delta0 = fPairCorr->GetPairingCorrection(fragment.GetA_asInt(),
+						    fragment.GetZ_asInt());
+
+  
+  G4double ParticleMass = fragment.ComputeGroundStateMass(theZ,theA);
+  G4double ResidualMass = fragment.ComputeGroundStateMass(ResidualZ,ResidualA);
+
+  G4double theSeparationEnergy = ParticleMass + ResidualMass 
+    - fragment.GetGroundStateMass();
+
+  G4double a0 = theEvapLDPptr->LevelDensityParameter(fragment.GetA_asInt(),
+						     fragment.GetZ_asInt(),
+						     U - delta0);
+
+  G4double a1 = theEvapLDPptr->LevelDensityParameter(ResidualA, ResidualZ,
+						     U - theSeparationEnergy - delta1);
+  
+  
+  G4double E0 = U - delta0;
+
+  G4double E1 = U - theSeparationEnergy - delta1 - K;
+
+  if (E1<0.) { return 0.; }
 
   //JMQ 14/02/09 BUG fixed: hbarc should be in the denominator instead of hbar_Planck 
   //Without 1/hbar_Panck remains as a width
-  //  G4double  Prob=Gamma*ParticleMass/((pi*hbar_Planck)*(pi*hbar_Planck)*
-  //std::exp(2*std::sqrt(a0*E0)))*K*CrossSection(fragment,K)*std::exp(2*std::sqrt(a1*E1))*millibarn;
 
   G4double Prob=Gamma*ParticleMass/((pi*hbarc)*(pi*hbarc)*std::exp(2*std::sqrt(a0*E0)))
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationChannel.cc	(revision 1340)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationChannel.cc	(revision 1347)
@@ -25,35 +25,19 @@
 //
 //
-// $Id: G4He3EvaporationChannel.cc,v 1.4 2006/06/29 20:10:33 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-ref-09 $
+// $Id: G4He3EvaporationChannel.cc,v 1.5 2010/11/17 12:14:59 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Nov. 1999)
 //
+// 17-11-2010 V.Ivanchenko moved constructor and destructor to source and cleanup
 
 #include "G4He3EvaporationChannel.hh"
 
+G4He3EvaporationChannel::G4He3EvaporationChannel() 
+: G4EvaporationChannel(3,2,"He3",&theEvaporationProbability,&theCoulombBarrier) 
+{}
 
-const G4He3EvaporationChannel & G4He3EvaporationChannel::operator=(const G4He3EvaporationChannel & )
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4He3EvaporationChannel::operator= meant to not be accessable");
-    return *this;
-}
+G4He3EvaporationChannel::~G4He3EvaporationChannel() 
+{}
 
-G4He3EvaporationChannel::G4He3EvaporationChannel(const G4He3EvaporationChannel & ) : G4EvaporationChannel()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4He3EvaporationChannel::CopyConstructor meant to not be accessable");
-}
-
-G4bool G4He3EvaporationChannel::operator==(const G4He3EvaporationChannel & right) const 
-{
-    return (this == (G4He3EvaporationChannel *) &right);
-    //  return false;
-}
-
-G4bool G4He3EvaporationChannel::operator!=(const G4He3EvaporationChannel & right) const 
-{
-    return (this != (G4He3EvaporationChannel *) &right);
-    //  return true;
-}
-
